Lock
====

RWLock
------
..  doxygenclass:: paddle::RWLock
    :members:

ReadLockGuard
-------------
..  doxygenclass:: paddle::ReadLockGuard
    :members:

SpinLock
--------
..  doxygenclass:: paddle::SpinLock
    :members:

Semaphore
---------
..  doxygenclass:: paddle::Semaphore
    :members:

ThreadBarrier
-------------
..  doxygenclass:: paddle::ThreadBarrier
    :members:

LockedCondition
---------------
..  doxygenclass:: paddle::LockedCondition
    :members:
